;                                     12864J-2FLA      
	list      p=16f873         ; list directive to define processor
	radix	hex
	#include <p16f873.inc>     ; 
      __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _WRT_ENABLE_ON & _LVP_OFF & _DEBUG_OFF & _CPD_OFF 
Count		equ	0x20    ;       60h 
ColStolb     	equ	0x21	;col. stolbcov in 1 controller - 64dec 
ColPage		equ	0x22	;col. stranic - 8                                     
Temp1		equ	0x23	;                 
DataADCl        equ	0x24	;bin (low)   . .               
DataADCh	equ	0x25	;(high)           
kX		equ	0x27	; 
Temp		equ	0x28
tmp1		equ	0x29    ;    1
tmp2		equ	0x2A    ;    2
tmp3		equ	0x2B    ;    3
wrData		equ	0x2C    ; 
DataTzl         equ	0x2D    ;  DataTz1  
DataTz2         equ	0x2E    ;  DataTz2 
DecTz1          equ	0x2F
DecTz2          equ	0x30    ; 
DecTz3          equ	0x31    ; 
;wrData		equ	0x32    ;  
temp            equ	0x33    ;  
reg             equ	0x34    ;       
;================================================================================
		ORG     0x000             ; 
		clrf    PCLATH            ;  
  		goto    main              ; 
		ORG     0x004             ; 
    ; RA0 -  
    ; RA1 - in
    ; RA2 - in
    ; RA3 - in
    ; RA4 - in
    ; RA5 - in
    ; RB0 - E1
    ; RB1 - E2
    ; RB2 - RES
    ; RB3 - A0
    ; RB4 - E    / 
    ; RB5 - in 
    ; RB6 - in  
    ; RB7 - in 
    ; R0 -    
    ; RC1 -  
    ; RC2 - 
    ; RC3 - 
    ; RC4 - 
    ; RC5 - 
    ; RC6 - 
    ; RC7 - 
 ;=================================   ==============================
main    	bcf	STATUS,RP1		;bank 0,   
		bcf	STATUS,RP0		;
		clrf	PORTA
		clrf	PORTB
		clrf	PORTC
		movlw	B'10000001'             ; -32Tosc.
		movwf	ADCON0                  ;   R0  
		bsf	STATUS,RP0		;bank 1
		movlw	B'00000110'	        ; , 
		movwf	ADCON1			;  
		movlw	B'00111111'		;RA0,1,2,3,4,5 < in, 
		movwf	TRISA			;
		movlw	B'11100000'		;RB5,6,7 < in, RB0,1,2,3,4 > out , RB5-  
		movwf	TRISB			;
		movlw	0			;RC0-7 -> out (data LCD)        
		movwf	TRISC			;
		movlw	B'00000111'		;
		movwf	OPTION_REG		;
		clrf	PIE1                    ;  
		bcf 	STATUS,RP0 		;bank 0
		clrf	T1CON                   ;  1  
		clrf	INTCON                  ;  
		bsf	PORTB,2		        ;Reset LCD OFF, 
		call	tay1
		call	tay2
		movlw	B'00000101'             ;    30 .
		movwf	kX			;
        	call	tay4                    ; 
                call	Reset			; reset display
        	goto    D5                      ;      30 .   
start1     ;==============================================================	
               	call	tay4                    ; 
		btfss	PORTB,7			
		goto    Pusk1 			; 
		btfss	PORTB,6			;
                goto    WD			;   
		call	tay3			;
		goto 	start1			;
start2     ;==============================================================	
               	call	tay4                    ; 
		btfss	PORTB,7			
		goto    Pusk2 			; 
		btfss	PORTB,6			;
                goto    WD			;   
		call	tay3			;
		goto 	start2			;
start3     ;==============================================================	
               	call	tay4                    ; 
		btfss	PORTB,7			
		goto    Pusk3 			; 
		btfss	PORTB,6			;
                goto    WD			;   
		call	tay3			;
		goto 	start3			;
Reset      ; =================================================  -   
                bsf	PORTB,0		        ;E1<-1          - .  
		bsf	PORTB,1		        ;E2<-1
		call	tay1
		bcf	PORTB,2		        ;	
		call	tay1
		bsf	PORTB,2		        ;
		call	tay1
           ;--------- display ON -------------
		bcf	PORTB,4		        ;E<-0
		bcf	PORTB,3		        ;A0<-0,
		nop
		movlw	B'00111111'	        ;3F -  data Display <- ON
		movwf	PORTC		        ;
		call	tay1
		bsf	PORTB,4   	        ;E<-1, enable write
		call	tay1
		bcf	PORTB,4		        ;E<-0, end write
		clrf	PORTC
		call	tay2
clrScr    ;=========================   =================
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;         	
		movlw	0x40			;number stolbcov in 1 controller
		movwf	ColStolb		;40h -> 64dec        .  = 64
		clrf	ColPage			;col. stranic
	        bcf	PORTB,1	        	;E2<-0
		nop
		bsf	PORTB,0		        ;E1<-1, 1 crystal
		nop
clrNextPg       movf	ColPage,W		;number page    -  
		movwf	PORTC			;set page
		call	setPage
		clrf	PORTC			;set stolb <- 0 -   
		call	setColon
clrNext		clrf	PORTC			;data<-0
		call	wrBit
		decfsz	ColStolb,F
		goto	clrNext			;next stolb
		movlw	0x40			; 40h = 64dec
		movwf	ColStolb
		incf	ColPage,F
		btfss	ColPage,3
		goto	clrNextPg		;ColPage<8, Next page		
		btfss	PORTB,0			;ColPage=8, end crystal  ?
		goto	endScr			;E1=0
		bcf	PORTB,0		        ;E1=1, E1<-0
		bsf	PORTB,1		        ;E2<-1, 2 crystal ON
		clrf	ColPage
		goto	clrNextPg
endScr          bsf	PORTB,0			;E1<-1, screen ON
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;   
		call	tay3
		return
Pusk1     ;========================      ===========
                clrf    DataADCh
		bcf	STATUS,IRP		;  1
                clrf    PORTA                   ;
		movlw	0xA0                    ; 0 -     
		movwf	FSR			; FF -      1 
nextRAM12       call	tayPusk                 ;    1  256-160=96 
                call    IzmerADC
		movf	DataADCh,W              ; 
		movwf	INDF			;    
		incfsz	FSR,F			; next adr RAM 
		goto	nextRAM12		;
          ;--------------------- 0,60h=96dez       0
		movlw	0x60			; 128 -      0 
		movwf	FSR			;    0  128-96=32 
nextRAM02       call	tayPusk                 ;     96+32=128 (  128 .)
		call	IzmerADC
		movf	DataADCh,W
		movwf	INDF			;    
		incf	FSR,F			; next adr.RAM
		btfss	FSR,7                   ; 80h = 104dez
		goto	nextRAM02		; 
		call	Reset			;  
		call    DISPL
		goto	start1 
Pusk2   ;=======================       =============
                clrf    DataADCh
		bcf	STATUS,IRP		; bank 0,1 
                clrf    PORTA                   ;
		movlw	0xA0                    ; 0=160 -     
		movwf	FSR			; FF=256 -      1 
nextRAM1        call	IzmerADC                ;   1  256-160=96 
		movf	DataADCh,W              ; 
		movwf	INDF			;    
		incfsz	FSR,F			; next adr RAM 
		goto	nextRAM1		;
        ;-----------------------  0,60h=96dez -       0
		movlw	0x60			; 80=128 -      0 
		movwf	FSR			;    0  128-96=32 
nextRAM0        call	IzmerADC                ;     96+32=128 (  128 .)
		movf	DataADCh,W
		movwf	INDF			;    
		incf	FSR,F			; next adr.RAM
		btfss	FSR,7                   ; 80h = 104dez
		goto	nextRAM0		; 
		call	Reset			;  
		call    DISPL
		goto	start2 	
Pusk3    ;======================       ===========
                clrf    DataADCh
		bcf	STATUS,IRP		;  1
                clrf    PORTA                   ;
		movlw	0xA0                    ; 0=160 -     
		movwf	FSR			; FF=256 -      1 
nextRAM13       call    IzmerIMP                ;    1  256-160=96 
                movf	DataADCh,W              ; 
		movwf	INDF			;    
		incfsz	FSR,F			; next adr RAM 
		goto	nextRAM13		;
         ;-----------------------  0,60h = 96dez -       0
		movlw	0x60			; 80=128 -      0 
		movwf	FSR			;    0  128-96=32 
nextRAM03       call	IzmerIMP                ;     96+32=128 (  128 .)
		movf	DataADCh,W
		movwf	INDF			;    
		incf	FSR,F			; next adr.RAM
		btfss	FSR,7                   ; 80h = 104dez
		goto	nextRAM03		; 
		call	Reset			;  
		call    DISPL
		goto	start3 
DISPL    ;========================         1==========
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		clrf	PORTC
		bcf	PORTB,1		        ;E2<-0              .2 
		bsf	PORTB,0		        ;E1<-1, 1 crystal - .1 
		call	tay1
		movlw	0x40			;number stolbcov in 1 controller
		movwf	ColStolb		;40h = 64dec         
 		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		movlw	B'01000000'		; 0 
		movwf	PORTC			;
		bsf	PORTB,4	        	;E<-1,  
		call	tay1
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		bcf	STATUS,IRP		;bank 0,1 
		movlw	0xA0                    ; 0 -      1
		movwf	FSR			;
nextStolb1     	movf	INDF,W                  ;-----------  .  W-------------------
                movwf   DataADCh
	        comf	DataADCh,F	        ; invert		
		movlw	B'00111111'	        ;  
		andwf	DataADCh,F	        ;high 6 bit	
                movf	DataADCh,W              ;
               	movwf	DataADCl		;dataRAM->DataADCl
	;------- nomer stranicy ---     
		movwf	DataADCh
		rrf	DataADCh,F              ;   
		rrf	DataADCh,F
		rrf	DataADCh,F	        ; nomer stranicy
		movlw	B'00000111'             ;  , w f
		andwf	DataADCh,W		; select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		; N page - 0 ( =8 ,,,F)
		iorwf	PORTC,F                 ;   W  F,    
 		bcf	PORTB,4		        ;   
		bcf	PORTB,3		        ;  
		nop
		bsf	PORTB,4		        ; E<-1, . 1  - ()
		call	tay1
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
	;-------- data -> screen ------     
		movlw	B'00000111'             ; 
		andwf	DataADCl,F		;     W 
		movlw	B'00000001'
		movwf	tmp1
sdvig1         	movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr1		;DataADCl=0
		decf	DataADCl,F		;DataADCl>0
		bcf	STATUS,C
		rlf	tmp1,F                  ;   
		goto	sdvig1
writScr1       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		call	tay1
		bsf	PORTB,3		        ;A<-1, 0=1 -    
		nop
		bsf	PORTB,4		        ;E<-1, 
		call	tay1
		bcf	PORTB,4		        ;E<-0 
		call	tay1
	        bcf	PORTB,3		        ; 0=0 - . 
		incf	FSR,F			; next RAM(bank 1)
		decfsz	ColStolb,F		; control end crystal
		goto	nextStolb1		; next stolb(bank 1)
		bcf	PORTB,0	        	; . 1 
	;-------- RAM 1bank -> 2 crystal -----------
		bsf	PORTB,1		        ; . 2 
		call	tay1
nextStolb2     	movf	INDF,W
               	movwf     DataADCh
	        comf	DataADCh,F	        ;invert	
		movlw	B'00111111'	        ; 
		andwf	DataADCh,F	        ;high 6 bit	
                movf	DataADCh,W              ;
		movwf	DataADCl		;
	;------- nomer stranicy --------
		movwf	DataADCh
		rrf	DataADCh,F
		rrf	DataADCh,F
		rrf	DataADCh,F      	;nomer stranicy
		movlw	B'00000111'
		andwf	DataADCh,W		;select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		;N page - 0
		iorwf	PORTC,F
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ;  
		nop
		bsf	PORTB,4	        	; .   
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
	;----------------------------    
		movlw	B'00000111'
		andwf	DataADCl,F		;data page
		movlw	B'00000001'
		movwf	tmp1
sdvig2          movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr2		;DataADCl=0
		decf	DataADCl,F		;DataADCl>0
		bcf	STATUS,C
		rlf	tmp1,F
		goto	sdvig2
writScr2       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		nop
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,3		        ; write screen
		nop
		bsf	PORTB,4		        ; .   
		call	tay1
		bcf	PORTB,4		        ;
		call	tay1
		decf	ColStolb,F	
		incfsz	FSR,F			;next RAM(bank 1)
		goto	nextStolb2		;next stolb(bank 1)
	;---------------------        0  2 
		movlw	0x60			;
		movwf	FSR			;
nextStolb3     	movf	INDF,W
               	movwf   DataADCh
	        comf	DataADCh,F	        ;invert 	
		movlw	B'00111111'	        ; 
		andwf	DataADCh,F	        ;high 6 bit	
               	movf	DataADCh,W              ;
		movwf	DataADCl		;
	;------- nomer stranicy --------
		movwf	DataADCh
		rrf	DataADCh,F
		rrf	DataADCh,F
		rrf	DataADCh,F	        ;nomer stranicy
		movlw	B'00000111'
		andwf	DataADCh,W		;select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		;N page - 0
		iorwf	PORTC,F
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ; 
		nop
		bsf	PORTB,4		        ;  
		call	tay1
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ; 
	;-------- data -> screen --------------
		movlw	B'00000111'
		andwf	DataADCl,F		;data page
		movlw	B'00000001'
		movwf	tmp1
sdvig3         	movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr3		;
		decf	DataADCl,F		;
		bcf	STATUS,C
		rlf	tmp1,F
		goto	sdvig3
writScr3       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		nop
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,3		        ; write screen
		nop
		bsf	PORTB,4		        ;  
		call	tay1 
		bcf	PORTB,4		        ;
		call	tay1
		decf	ColStolb,F
		incf	FSR,F			;
		btfss	FSR,7
		goto	nextStolb3		;next stolb(bank 0)
		bsf	PORTB,0		        ;1 crystal-> screen
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay3
		return
IzmerADC  ;============================      ============================
		bsf	ADCON0,GO       	;start ADC - .
		btfsc	ADCON0,GO               ; 
		goto	$-1		        ;not ready
		movf	ADRESH,W	        ;   ADRESH   DataADCh
		movwf	DataADCh
		return
IzmerIMP  ;============================   ==========================
                clrf	DataADCh
                BTFSS   PORTA,1                 ;
                BSF	DataADCh,5            	;
                return
wrBit  ; ===========================      ====================
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 	
		call	tay1
		call	tay1
		bsf	PORTB,3			; write screen
		call	tay1
		bsf	PORTB,4			; enable wr.screen
		call	tay1
		call	tay1
		bcf	PORTB,4			;
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; set Stolb
		call	tay1
		return
setColon ;-----------------------   ------------------
		bsf	PORTC,6			;    
		call	tay1                    ;
		bsf	PORTB,4			; 
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		return
setPage ;----------------------------   ---------------
		movlw	B'10111000'		; 8 -  
		iorwf	PORTC,F                 ;   W  F    
		nop                             ;      
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,4			; 
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		return
WD     ; =======================     ===============
                CALL    tay3                    ; 
                INCF    kX ,1                   ; +1  . kX
	        MOVF	kX,0
                SUBLW   0x09                    ; 
	        BTFSS	STATUS,2                ;
	        GOTO	WD1
                MOVLW   .1                      ; 1  kX /  1 /
                MOVWF   kX                      ;
WD1
	MOVF	kX,0
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D1          ; 3 .
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D2          ; 1 .
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D3          ; 300 . 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D4          ; 100 ..
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D5          ; 30 . .
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D6          ; 10 ..
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D7          ; 2,7 .. 
	ADDLW	-1	    ;
	BTFSC	STATUS,2    ;
	GOTO	D8          ;  260 . .  
	GOTO	start1
D1 
        CALL	DLIT            ;   " "
        CALL    SEK3            ; "3 " 
	call	tay4
        movlw   0xE0  
        movwf   DataTz2         ; 
        movlw   0xB0
        movwf   DataTzl         ; 
        GOTO	Pusk1 
D2 
        CALL	DLIT            ;    
        CALL    SEK1            ;  1   
        call	tay4  
        movlw   0xA7  
        movwf   DataTz2         ; 
        movlw   0x50
        movwf   DataTzl       ; 
        GOTO	Pusk1           
D3 
        CALL	DLIT            ;    
        CALL    S03               ; 300 .       
        call	tay4
        movlw   0xB0  
        movwf   DataTz2       ; 
        movlw   0x14
        movwf   DataTzl       ;   
        GOTO	Pusk1           
D4 
        CALL	DLIT          ;    
        CALL    S01           ; 100 .      
        call	tay4
        movlw   0x7E  
        movwf   DataTz2       ; 
        movlw   0x9
        movwf   DataTzl       ; 
        GOTO	Pusk1 	
D5 
        CALL	DLIT          ;    
        CALL    MS30          ; 30 .     
        call	tay4
        movlw   0x54  
        movwf   DataTz2       ; 
        movlw   0x3
        movwf   DataTzl       ; 
        GOTO	Pusk1 
D6 
        CALL	DLIT          ;    
        CALL    MS10          ; 10 .      
        call	tay4
        movlw   0x16  
        movwf   DataTz2       ; 
        movlw      0x3
        movwf   DataTzl       ; 
        GOTO	Pusk1 
D7
        CALL	DLIT          ;    
        CALL    MS3           ; 2,7 .   
        call	tay4
        GOTO	Pusk2  
D8
        CALL	DLIT          ;    
        CALL    MS03          ; 260 .   
        call	tay4
        GOTO	Pusk3
krist_1    bcf         PORTB,1           ;  2    - E2
           bsf         PORTB,0           ;   1    - E1
           return
krist_2    bcf         PORTB,0           ;   1   - E1
           bsf         PORTB,1             ;  2   - E2
           return
ctr_1      movlw       b'10111000'       ; 8 -   1 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_2      movlw       b'10111001'       ;   2 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_3      movlw       b'10111010'       ;   3 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_4      movlw       b'10111011'       ;   4 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_5      movlw       b'10111100'       ;   5 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_6      movlw       b'10111101'       ;   6 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_7      movlw       b'10111110'       ;   7 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctr_8      movlw       b'10111111'       ;   8 .     
           movwf       PORTC
           call        strobe           ;  
           return
zap_dan                                  ;  
           bsf         PORTB,3           ;      - A0
           call        strobe           ;  
           bcf         PORTB,3           ;             - A0
           return
strobe                                  ;  
           bsf         PORTB,4           ;  E  - 
           call        tay1
           bcf         PORTB,4           ;  
           call        tay1
           return
vert_0     movlw       b'01000000'       ;  40 -   0 .     
           movwf       PORTC
           call        strobe           ;  
           return
ctroka_0   movlw       b'11000000'       ; 0 -   0      
           movwf       PORTC
           call        strobe           ;  
           return
tayPusk   ;------------------------   -----------------
		movf	DataTz2,W
		movwf	DecTz2
tayP2	        movf	DataTzl,W
		movwf	DecTz1
tayP1	        decfsz	DecTz1,F
		goto 	tayP1
		decfsz	DecTz2,F
		goto	tayP2
		return
tay1      ;----------------------------   10 ..--------------
                movlw	0x07
		movwf	tmp1
looptay1        decf	tmp1,F
		nop
		btfss	STATUS,Z
		goto	looptay1
		return
tay2      ;----------------------------  2 ---------------------------
             	movlw	H'35'
		movwf	tmp1
looptay2       	movlw	H'11'
		movwf	tmp2
looptmp2       	decf	tmp2,F
		btfss	STATUS,Z
		goto	looptmp2
		decf	tmp1,F
		btfss	STATUS,Z
		goto	looptay2
		return
tay3  ;---------------------------------  3 ----------------------------
               	movlw	0xFF
		movwf	tmp1
looptay3       	movlw	0xFF
		movwf	tmp2
looptmp3       	decf	tmp2,F
		btfss	STATUS,Z
		goto	looptmp3
		decf	tmp1,F
		btfss	STATUS,Z
		goto	looptay3
		return
tay4  ;--------------------------------------  4 ---------------------------
               	movlw	0x10                
		movwf	tmp1
tay41          	movlw	0xFF
		movwf	tmp2
tay42          	movlw	0xFF
		movwf	tmp3
tay43          	decf	tmp3,F
		btfss	STATUS,Z
		goto	tay43
		decf	tmp2,F
		btfss	STATUS,Z
		goto	tay42
		decf	tmp1,F
		btfss	STATUS,Z
		goto	tay41
		return
DLIT    ;=================================   " "    
;----------------------------------------------------------------------------- 
;   12864J
;-----------------------------------------------------------------------------  
           bcf	       STATUS,RP1        ;bank 0
           bcf	       STATUS,RP0	 ;
           bsf         PORTB,0           ;     - E1
           bsf         PORTB,1           ;                           - E2 
           movlw       .7                ;  13 (   3 )
           movwf       temp 
m_1        decfsz      temp
           goto        m_1
           movlw       3E                ;  "Display OFF"
           movwf       PORTC
           call        strobe            ;  . 
           movlw       3F                ;  "Display ON"
           movwf       PORTC
           call        strobe            ;  . 
           movlw       .7                ;  13 (   3 )
           movwf       temp 
m_2        decfsz      temp
           goto        m_2
;----------------------------------------------------------------------------- 
;   1                   DLIT  
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   1. 1                 DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_1             ;  
           call        vert_0            ;  0 
           movlw       .64               ; 
           movwf       temp              ;      . 
WR_1       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp =     reg
           movwf       reg               ;        
           movlw       high TEXT_1       ;       TEXT_1   w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_1)
           call        TEXT_1            ;    TEXT_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_1              ;    =0,     WR_1
;----------------------------------------------------------------------------- 
;   2. 1                   DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_2             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_2       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_2       ;       TEXT_2   w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_2)
           call        TEXT_2            ;    TEXT_2. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_2              ;    =0,     WR_2
;----------------------------------------------------------------------------- 
;   3. 1                 DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_3             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_3       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_3       ;       TEXT_3  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_3)
           call        TEXT_3            ;    TEXT_3. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_3              ;    =0,     WR_3
;----------------------------------------------------------------------------- 
;   4. 1                   DLIT  
;----------------------------------------------------------------------------- 
           call        ctr_4             ;  
           call        vert_0            ;  0   
           movlw       .64               ; 
           movwf       temp              ;       
WR_4       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_4       ;       TEXT_4  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_4)
           call        TEXT_4            ;    TEXT_4. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_4              ;    =0,     WR_4
;----------------------------------------------------------------------------- 
;   5. 1                     DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_5             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_5       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_5       ;       TEXT_5  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_5)
           call        TEXT_5            ;    TEXT_5. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_5              ;    =0,     WR_5
;----------------------------------------------------------------------------- 
;   6. 1                     DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_6             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_6       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_6       ;       TEXT_6  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_6)
           call        TEXT_6            ;    TEXT_6. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_6              ;    =0,     WR_6
;----------------------------------------------------------------------------- 
;   8. 1                  DLIT  
;-----------------------------------------------------------------------------
           call        ctr_8             ;  
           call        vert_0            ;  0    
           movlw       .64               ; 
           movwf       temp              ;       
WR_8       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_8       ;       TEXT_8  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_8)
           call        TEXT_8            ;    TEXT_8. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_8              ;    =0,     WR_8 
;----------------------------------------------------------------------------- 
;   2                  DLIT  
;-----------------------------------------------------------------------------
           call        krist_2
           call        ctroka_0    
;----------------------------------------------------------------------------- 
;   1. 2                  DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_1             ;  
           call        vert_0            ;  0    
           movlw       .64               ; 
           movwf       temp              ;       
WR_1_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_1_1     ;       TEXT_1_1   w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_1)
           call        TEXT_1_1          ;    TEXT_1_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_1_1            ;    =0,     WR_1_1
;----------------------------------------------------------------------------- 
;   2. 2                  DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_2             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_2_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_2_1     ;       TEXT_2_1   w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_2)
           call        TEXT_2_1          ;    TEXT_2_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_2_1            ;    =0,     WR_2_1
;----------------------------------------------------------------------------- 
;   3. 2                  DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_3             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_3_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_3_1     ;       TEXT_3_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_3)
           call        TEXT_3_1          ;    TEXT_3_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_3_1            ;    =0,     WR_3_1
;----------------------------------------------------------------------------- 
;   4. 2                 DLIT  
;----------------------------------------------------------------------------- 
           call        ctr_4             ;  
           call        vert_0            ;  0   
           movlw       .64               ; 
           movwf       temp              ;       
WR_4_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_4_1     ;       TEXT_4_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_4)
           call        TEXT_4_1          ;    TEXT_4_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_4_1            ;    =0,     WR_4_1
;----------------------------------------------------------------------------- 
;   5. 2                  DLIT  
;-----------------------------------------------------------------------------  
           call        ctr_5             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_5_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_5_1     ;       TEXT_5_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_5_1)
           call        TEXT_5_1          ;    TEXT_5_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_5_1            ;    =0,     WR_5_1
;----------------------------------------------------------------------------- 
;   6. 2                   DLIT  
;----------------------------------------------------------------------------- 
           call        ctr_6             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_6_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_6_1     ;       TEXT_6_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_6_1)
           call        TEXT_6_1          ;    TEXT_6_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_6_1            ;    =0,     WR_6_1
;----------------------------------------------------------------------------- 
;   7 . 2                     DLIT  
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_1     ;       TEXT_7_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7_1)
           call        TEXT_7_1          ;    TEXT_7_1. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_1            ;    =0,     WR_7_1
;----------------------------------------------------------------------------- 
;   8 . 2                      DLIT  
;-----------------------------------------------------------------------------
           call        ctr_8             ;  
           call        vert_0            ;  0    
           movlw       .64               ; 
           movwf       temp              ;       
WR_8_1     movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_8_1     ;       TEXT_8_1  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_8_1)
           call        TEXT_8_1          ;    TEXT_8_1.  
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_8_1            ;    =0,     WR_8_1  
           return
SEK3       ;======================================================================      
;----------------------------------------------------------------------------- 
;   1                  SEK3
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1            SEK3
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_11       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_11       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_11            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_11              ;    =0,     WR_7
             return
SEK1                  ;=======================================================================
;----------------------------------------------------------------------------- 
;   1                  SEK1 
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1          SEK1   
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_12       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_12       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_12            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_12              ;    =0,     WR_7
             return
S03
;----------------------------------------------------------------------------- 
;   1 
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1 
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_13       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_13       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_13            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_13              ;    =0,     WR_7
             return
S01
;----------------------------------------------------------------------------- 
;   1                  S01
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1                S01
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_14       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_14       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_14            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_14              ;    =0,     WR_7
            return
MS30
;----------------------------------------------------------------------------- 
;   1 
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1 
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_15       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_15       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_15            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_15              ;    =0,     WR_7
             return
MS10
;----------------------------------------------------------------------------- 
;   1                  MS10
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1                   MS10
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_16       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_16       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_16            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_16              ;    =0,     WR_7
             return
MS3
;----------------------------------------------------------------------------- 
;   1 
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1                       MS3
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_17       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_17       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_17            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_17              ;    =0,     WR_7
             return
MS03
;----------------------------------------------------------------------------- 
;   1 
;-----------------------------------------------------------------------------
           call        krist_1
           call        ctroka_0          ;   0  1 
;----------------------------------------------------------------------------- 
;   7 . 1                       MS03
;-----------------------------------------------------------------------------
           call        ctr_7             ;  
           call        vert_0            ;  0  
           movlw       .64               ; 
           movwf       temp              ;       
WR_7_18       movf        temp,W            ;    temp  W.
           sublw       .64               ; .64 - temp = ... (   W).
           movwf       reg               ; reg       
           movlw       high TEXT_7_18       ;       TEXT_7  w
           movwf       PCLATH            ;  W  PCLATH (    .  TEXT_7)
           call        TEXT_7_18            ;    TEXT_7. 
           movwf       PORTC             ;    . .   PORTD
           movlw       high zap_dan      ;       zap_dan   w
           movwf       PCLATH            ;  W  PCLATH 
           call        zap_dan           ;    
           decfsz      temp,F            ;       
           goto        WR_7_18              ;    =0,     WR_7
             return             
;----------------------------------------------------------------------------- 
;  1  1         " "   ==========================================
;----------------------------------------------------------------------------- 
TEXT_1     movlw       high ctpa_1       ; "."        ctpa_1   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_1        ; c w    PC  ctpa_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ;  +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_1
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  2  1               "."
;----------------------------------------------------------------------------- 
TEXT_2     movlw       high ctpa_2       ;  "."       ctpa_2   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_2        ; c w    PC  ctpa_2
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_2  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xE0,0x3F,0x21,0x21,0x3F,0xE0,0x00
            Dt            0x00,0x80,0xFF,0x01,0x01,0xFF,0x00,0x00
            Dt            0x00,0xFF,0x10,0x08,0x04,0xFF,0x00,0x00
            Dt            0x00,0x01,0x01,0xFF,0x01,0x01,0x00,0x00
            Dt            0x00,0x00,0xFF,0x89,0x89,0x89,0x81,0x00
            Dt            0x00,0x80,0xFF,0x01,0x01,0xFF,0x00,0x00
;----------------------------------------------------------------------------- 
;  3  1                "."
;----------------------------------------------------------------------------- 
TEXT_3     movlw       high ctpa_3       ;  "."       ctpa_3   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_3        ; c w    PC  ctpa_3
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_3  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x40,0x00,0x40,0x00,0x00
;----------------------------------------------------------------------------- 
;  4  1                  "."
;----------------------------------------------------------------------------- 
TEXT_4     movlw       high ctpa_4       ; "."       ctpa_4   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_4        ; c w    PC  ctpa_4
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_4  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0xFF,0x11,0x11,0x11,0x1F,0x00
            Dt            0x00,0x00,0xFF,0x09,0x09,0x09,0xFF,0x00
            Dt            0x00,0x00,0x81,0x89,0x89,0xFF,0x00,0x00
            Dt            0x00,0x00,0xFF,0x89,0x89,0x89,0xFF,0x00
            Dt            0x00,0x00,0xFF,0x89,0x89,0x89,0x81,0x00
;----------------------------------------------------------------------------- 
;  5  1              "."
;----------------------------------------------------------------------------- 
TEXT_5     movlw       high ctpa_5       ;  "."       ctpa_5   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_5        ; c w    PC  ctpa_5
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_5  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  6  1              "."
;----------------------------------------------------------------------------- 
TEXT_6     movlw       high ctpa_6       ;  "."       ctpa_6   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_6        ; c w    PC  ctpa_6
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_6  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  8  1                 "."
;----------------------------------------------------------------------------- 
TEXT_8     movlw       high ctpa_8       ;  "."       ctpa_8   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_8        ; c w    PC  ctpa_8
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_8  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  1  2                   "."
;----------------------------------------------------------------------------- 
TEXT_1_1   movlw       high ctpa_1_1     ; "."       ctpa_1_1   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_1_1      ; c w    PC  ctpa_1_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_1_1 Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 
;----------------------------------------------------------------------------- 
;  2  2                 "."
;----------------------------------------------------------------------------- 
TEXT_2_1   movlw       high ctpa_2_1     ;  "."       ctpa_2_1   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_2_1      ; c w    PC  ctpa_2_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_2_1  Dt        0x00,0x00,0xFF,0x88,0x88,0x88,0xF8,0x00
            Dt            0x00,0x00,0xFF,0x08,0x08,0x08,0xFF,0x00
            Dt            0x00,0x00,0xFF,0x81,0x81,0x81,0xFF,0x00
            Dt            0x00,0x00,0xFF,0x81,0x81,0x81,0x00,0x00
            Dt            0x00,0x01,0x01,0xFF,0x01,0x01,0x00,0x00
            Dt            0x00,0xFF,0x88,0x88,0x88,0xF8,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  3  2             "."
;----------------------------------------------------------------------------- 
TEXT_3_1   movlw       high ctpa_3_1     ;  "."       ctpa_3_1  w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_3_1      ; c w    PC  ctpa_3_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_3_1 Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 
;----------------------------------------------------------------------------- 
;  4  2                 "."
;----------------------------------------------------------------------------- 
TEXT_4_1   movlw       high ctpa_4_1     ;  "."       ctpa_4_1   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_4_1      ; c w    PC  ctpa_4_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_4_1  Dt            0x00,0x00,0xFF,0x11,0x11,0x11,0x1F,0x00
            Dt            0x00,0x01,0x01,0xFF,0x01,0x01,0x00,0x00
            Dt            0x00,0xFF,0x08,0x08,0x17,0xE1,0x80,0x00
            Dt            0x00,0x00,0xFF,0x10,0x08,0x04,0xFF,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  5  2  (    ,   )
;----------------------------------------------------------------------------- 
TEXT_5_1   movlw       high ctpa_5_1     ;  "."       ctpa_5_1  w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_5_1      ; c w    PC  ctpa_5_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_5_1  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  6  2                 "."
;----------------------------------------------------------------------------- 
TEXT_6_1   movlw       high ctpa_6_1     ;  "."       ctpa_6_1   w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_6_1      ; c w    PC  ctpa_6_1 
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_6_1  Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  2           "."
;----------------------------------------------------------------------------- 
TEXT_7_1   movlw       high ctpa_7_1     ;  "."       ctpa_7_1    w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_1      ; c w    PC  ctpa_7_1 
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_1  Dt            0x00,0xFF,0x81,0x81,0x81,0x81,0x00,0x00
            Dt            0x00,0x00,0xFF,0x89,0x89,0x89,0x81,0x00
            Dt            0x00,0x00,0xFF,0x08,0x08,0x17,0xE1,0x80
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  8  2        "."
;----------------------------------------------------------------------------- 
TEXT_8_1   movlw       high ctpa_8_1     ;  "."       ctpa_8_1  w
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_8_1      ; c w    PC  ctpa_8_1
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_8_1    Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
 ;----------------------------------------------------------------------------- 
;  7  1                 SEK3
;----------------------------------------------------------------------------- 
TEXT_7_11     movlw       high ctpa_7_11       ;  SEK3       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_11        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_11   Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x81,0x89,0x89,0x89,0xFF,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00       
;----------------------------------------------------------------------------- 
;  7  1                 SEK1
;----------------------------------------------------------------------------- 
TEXT_7_12     movlw       high ctpa_7_12       ;  SEK1       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_12        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_12   Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x04,0x06,0xFF,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  1                S03 
;----------------------------------------------------------------------------- 
TEXT_7_13     movlw       high ctpa_7_13 ;  S03        ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_13        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_13   Dt     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x81,0x89,0x89,0xFF,0x00,0x00,0xFF,0x81
            Dt            0x81,0xFF,0x00,0x00,0xFF,0x81,0x81,0xFF
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0x80,0xFF,0x01,0x01,0x01,0xFF,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  1                         S01
;----------------------------------------------------------------------------- 
TEXT_7_14  movlw       high ctpa_7_14       ;       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_14        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_14   Dt   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x04,0x06,0xFF,0x00,0x00,0xFF,0x81
            Dt            0x81,0xFF,0x00,0x00,0xFF,0x81,0x81,0xFF
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0x80,0xFF,0x01,0x01,0x01,0xFF,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  1                       MS30
;----------------------------------------------------------------------------- 
TEXT_7_15  movlw       high ctpa_7_15       ;       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_15        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_15   Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x81,0x89
            Dt            0x89,0xFF,0x00,0x00,0xFF,0x81,0x81,0xFF
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0x80,0xFF,0x01,0x01,0x01,0xFF,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00 
;----------------------------------------------------------------------------- 
;  7  1            MS10
;----------------------------------------------------------------------------- 
TEXT_7_16     movlw       high ctpa_7_16       ;       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_16        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_16  Dt      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x02,0xFF,0x00,0x00,0xFF,0x81,0x81,0xFF
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0x80,0xFF,0x01,0x01,0x01,0xFF,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  1                  MS3
;----------------------------------------------------------------------------- 
TEXT_7_17     movlw       high ctpa_7_17       ;       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_17     ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_17   Dt     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x81,0x89,0x89,0xFF
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0x80,0xFF,0x01,0x01,0x01,0xFF,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
;----------------------------------------------------------------------------- 
;  7  1          MKS300
;----------------------------------------------------------------------------- 
TEXT_7_18     movlw       high ctpa_7_18       ;       ctpa_7   w         !!!
           movwf       PCLATH 
                                         ;          ( 256 )     
           movf        reg,w             ;   w ( )
           addlw       low ctpa_7_18        ; c w    PC  ctpa_7                                              !!!
           btfsc       STATUS,C          ;    ()
           incf        PCLATH,f          ; , +1  PCLATH
           movf        reg,w             ;  , . .
           addwf       PCL,F             ;  PCL    W.
ctpa_7_18   Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0x00,0x00,0x00,0x81,0x89,0x89,0xFF
            Dt            0x00,0xFF,0x81,0x81,0xFF,0x00,0xFF,0x81
            Dt            0x81,0xFF,0x00,0x00,0x00,0x00,0x00,0x00
            Dt            0x00,0xFF,0x02,0x04,0x08,0x04,0x02,0xFF
            Dt            0x00,0xFF,0x08,0x08,0x17,0xE1,0x80,0x00
            Dt            0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00
			END                             ;
